var http = require('http'),
  fs = require('fs'),
  faye = require('faye'),
  fayeRedis = require('faye-redis'),
  process = require('process'),
  env = process.env,
  yaml = require('js-yaml'),
  engineConf = {},
  serPort = parseInt(env["portslbhttp0"] || env["port.NODE_PORT"] || env["NODE_PORT"] || 8080),
  workers = parseInt(env.WORKERS || 1);

console.log("Server running at http://127.0.0.1:" + serPort);

if (env["REDIS_CONF"]) {
  engineConf = JSON.parse(env["REDIS_CONF"]);
  engineConf.type = fayeRedis;
}

if (!fs.existsSync("tmp")) fs.mkdirSync("tmp");
if (!fs.existsSync("tmp/pids")) fs.mkdirSync("tmp/pids");

fs.writeFileSync('tmp/pids/faye.' + serPort + '.pid', process.pid);

function createServer(port) {
  var server = http.createServer(),
    bayeux = new faye.NodeAdapter({
      mount:   '/faye',
      timeout: 45,
      engine:  engineConf
    });

  bayeux.attach(server);
  server.listen(port);
}

for(var i = 1; i < workers; i++) {
  setTimeout(createServer, 0, serPort + i);
}

createServer(serPort);
